﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;

namespace LINQBasicDemo {
	class Program {
		static void Main(string[] args) {
////			 Show all the country information in the list
//			 ShowEverything( );
//			
////			 Show only those countries starting with T
//			 ShowOnlyTs( );
//			
////			 Show everything, sorted descending by country name
//			 ShowEverythingSortedDescending();
//
////			 Show some calculated information that's not part
////			 of the original class
//			 SelectCalculatedInfo();

			Console.ReadLine();
		}

		public static void ShowEverything( ) {
			var filteredList = 
				from countryInfo in List
				select countryInfo;

			foreach(CountryInfo countryInfo in filteredList)
				Console.WriteLine(countryInfo);
		}

		public static void ShowOnlyTs( ) {
			var filteredList = 
				from countryInfo in List
					where countryInfo.Name.StartsWith("T")
				select countryInfo;

			foreach(CountryInfo countryInfo in filteredList)
				Console.WriteLine(countryInfo);
		}

		public static void ShowEverythingSortedDescending( ) {
			var filteredList = 
				from countryInfo in List
				orderby countryInfo.Name descending
				select countryInfo;

			foreach(CountryInfo countryInfo in filteredList)
				Console.WriteLine(countryInfo);
		}

		public static void SelectCalculatedInfo( ) {
			var filteredList = 
				from countryInfo in List
				select new {
					Name = countryInfo.Name,
					PopulationPerKM2 = countryInfo.Population / countryInfo.AreaKM2
				};

			foreach(var info in filteredList)
				Console.WriteLine(String.Format(
					"Country: {0}, Population per KM^2: {1}", 
					info.Name, info.PopulationPerKM2));
		}

		private static CountryInfoList list;
		public static CountryInfoList List {
			get {
				if (list == null)
					list = new CountryInfoList( );
				return list;
			}
		}
	}
}
