﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Query;
using QueryApp.DataWebService;
using System.Expressions;
using System.Reflection;

namespace QueryApplication {
	class Program {
		static void Main(string[] args) {
			var dataWebService = new Service( );

			var list = 
				from entry in new DataWebServiceQuery(dataWebService)
				where entry.Name.StartsWith("T")
				orderby entry.Population
			    select entry;

			foreach (CountryInfo countryInfo in list) {
				Console.WriteLine(
					String.Format("Country: {0}, Population: {1}, Area: {2}",
					countryInfo.Name, countryInfo.Population, countryInfo.AreaKM2));
			}

			Console.ReadLine( );
		}
	}
}